class pow {
  $POW_ROOT = "/Users/${id}/Library/Application Support/Pow"
  $POW_BIN = "${POW_ROOT}/Current/bin"
  $POW_VERSION = "0.4.3"

  file { "${POW_ROOT}": ensure => directory }
  file { "${POW_ROOT}/Hosts": ensure => directory }
  file { "${POW_ROOT}/Versions": ensure => directory }

  file { "/Users/${id}/.pow": ensure => link, target => "${POW_ROOT}/Hosts" }
  file { "${POW_ROOT}/Current": ensure => link, target => "${POW_ROOT}/Versions/${POW_VERSION}" }

  exec { "Installing Pow v${POW_VERSION}":
    command => "/usr/bin/curl -s http://get.pow.cx/versions/${POW_VERSION}.tar.gz | /usr/bin/tar xf -",
    creates => "${POW_ROOT}/Versions/${POW_VERSION}",
    cwd     => "${POW_ROOT}/Versions",
    require => [File["${POW_ROOT}/Versions"]],
  }

  $LaunchAgents = "/Users/${id}/Library/LaunchAgents"
  unless defined(File[$LaunchAgents]) {
    file { "${LaunchAgents}":
      ensure => directory,
      mode   => '0755',
    }
  }

  $plist = "${LaunchAgents}/cx.pow.powd.plist"
  exec { "Configuring Launch Agents":
    command     => "node ./pow --install-local",
    unless      => "curl -sH host:pow 'localhost:20559/status.json' | grep -qc '\"version\":\"${POW_VERSION}\"'",
    cwd         => $POW_BIN,
    path        => [$POW_BIN, '/usr/bin'],
    environment => ["HOME=/Users/${id}", "LOGNAME=${id}"],
    require     => [File[$LaunchAgents], File["${POW_ROOT}/Current"], Exec["Installing Pow v${POW_VERSION}"]],
    notify      => [Exec["Starting Pow"]],
  }

  $pow_is_running = "/usr/bin/curl -sH host:pow 'localhost:20559/status.json'"

  exec { "Starting Pow":
    command     => "/bin/launchctl unload ${plist}; /bin/launchctl load ${plist}",
    refreshonly => true,
  }

  exec { "Waiting for Pow":
    command   => $pow_is_running,
    unless    => $pow_is_running,
    tries     => 30,
    try_sleep => 1,
    require   => [Exec['Starting Pow']],
  }
}
